 %@@@@@@@@@@@@@@@@@ FULL CHALMS MODEL @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%    FARMERS    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for nf=1:Nfarmers
    str= sprintf('ifarmer = find(AGLAYER == idNfarmers(%d));',nf);
    eval(str);
    Farmstats(nf,2,1:TSTART)=length(find(AGLAYER==idNfarmers(nf)));
    LANDVALUE(ifarmer)=Farmstats(iNfarmers(nf),5,1);
end
PLAND=LANDVALUE;

for it=1:TSTART+1
    Farmstats(:,:,it)=Farmstats(:,:,1);
    wtaland(iNfarmers,it)=Farmstats(iNfarmers,5,1);
    Paskland(iNfarmers,it)=Farmstats(iNfarmers,5,1);
    Plandproj(iNfarmers,it)=Paskland(iNfarmers,it);
end

for lv=1:Nlots(1)
    lvind=Lottype((lv == Lottype(:,1)),2);
    LOTVALUE(lvind)=mean(LANDVALUE(lvind),1);
end

%%%%%%%%%%%% Construction Costs %%%%%%%%%%%%%%%

ccost_base=([201624.1197
264124.1197
326624.1197
208273.7676
270773.7676
333273.7676
217748.2394
280248.2394
342748.2394
232872.3592
295372.3592
357872.3592
238120.5986
300620.5986
363120.5986
256368.838
318868.838
381368.838])*discount;
ccost=ccost_base;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for i=1:length(Lottype(:,1))
    Lottype(i,6)=ccost(z(:,1)==Lottype(i,3) & z(:,2)==Lottype(i,4));
end
lotchoice(:,6)=Lottype(ilots,6);
for nl=1:Nlots(1)
    isamelot=find(Lottype(:,1)==lotchoice(nl,1));
    Rmin(nl,1)=ccost(lotchoice(nl,5));
    INRENT(Lottype(isamelot,2))=Rmin(nl,1);
    INITIALPASK(Lottype(isamelot,2))=Rmin(nl,1)-mean(travelcost(Lottype(isamelot,2)));
    wtahouse(nl,1)=Rmin(nl,1);
end

%%% initial vacant land
ivac=(VACLAND ~= 0);
RENTPROJLAND(iagr)=1;
BUILDTIME(iurb)=TSTART;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%    Consumers    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

CONINFO(1:Nconsumers,1)=alpha;
CONINFO(1:Nconsumers,2)=beta;
CONINFO(1:Nconsumers,3)=gamma;


%<><><><><><><><><>  Matching consumers with houses   <><><><><><><><><><>
Paskhouse(1:Nlots(1),1)=INITIALPASK(lotchoice(:,2));

deltadiff=zeros(1,[]);
utildiff=zeros(1,TMAX);
meandiffprice=5000;
utildiff(1:TSTART)=1000;
diffcheck=0;
stillvaccheck=0;
meanprice=zeros(LTYPE*HTYPE,[]);
iterhmc=zeros(1,[]);
diffvac=zeros(1,[]);
diffprice=zeros(1,[]);
iter=0;
deltaiter=1;
deltafac=1;
diffflag=0;
killflag=0;
vaccheck=Nconsumers;

%%%%%% Learning Period %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
while abs(deltafac) > 0.001
    Lottype(:,7)=0;
    lotchoice(:,7)=0;
    initialdiff=meandiffprice;
    initialutildiff=utildiff(TSTART);
    
    HouseMarketInitial
    
    if killflag==1
        break
    end
    
    iter=iter+1; 
    deltadiff(deltaiter)=meandiffprice;
    meandiffprice=mean(abs(Paskhouse-con2lot(:,1)));
    diffprice(1:length(Paskhouse),iter)=con2lot(:,1)-Paskhouse;
    diffvac(iter)=length(istillvac);
    
    deltaiter=deltaiter+1;
    
    for lt=1:12
        if isempty(find(lotchoice(:,5)==lt,1))==1
            continue
        end
        meanprice(lt,iter)=mean(con2lot(lotchoice(:,5)==lt,1));
    end
    iterhmc(length(iterhmc)+1)=avghousemp(TSTART);
    deltadiff(deltaiter)=meandiffprice;
    deltafac=(deltadiff(deltaiter-1)-deltadiff(deltaiter))/deltadiff(deltaiter-1);
    diffcheck=initialdiff-meandiffprice;
    utildiffcheck=initialutildiff-utildiff(TSTART);
    if iter > 2
        vaccheck=diffvac(iter-1)-diffvac(iter);
    end
    
    if diffcheck < 0 && utildiffcheck < 0 && abs(deltafac) < 0.01
        Paskhouse=savePaskhouse;
        killflag=1;
        continue
    elseif diffcheck < 0 && utildiffcheck < 0 && vaccheck < 0
        Paskhouse=savePaskhouse;
        killflag=1;
        continue
    end
    
    savePaskhouse=Paskhouse;
    Paskhouse=Paskhouse+abs(meandiffprice/mean(meanprice(meanprice(:,iter)~=0,iter))).*diffprice(:,iter);

    for n=1:length(ifilled)
        HU(con2lot(ifilled(n),2),1)=U(con2lot(ifilled(n),2),con2lot(ifilled(n),3));
        isamecell=find(Lottype(:,1)==con2lot(ifilled(n),3));
        RENT(Lottype(isamecell,2))=mean(con2lot(ifilled(n),1));
    end
    %%% Adjust rent for vacant houses
    RENT(lotchoice(istillvac,2))=con2lot(istillvac,1);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

MINBIDLEVEL(lotchoice(ifilled,2))=con2lot(ifilled,1)./Paskhouse(ifilled);

for n=1:length(ifilled)
    HU(con2lot(ifilled(n),2),1)=U(con2lot(ifilled(n),2),con2lot(ifilled(n),3));
    isamecell=find(Lottype(:,1)==con2lot(ifilled(n),3));
    RENT(Lottype(isamecell,2))=mean(con2lot(ifilled(n),1));
end
%%% Adjust rent for vacant houses
RENT(lotchoice(istillvac,2))=con2lot(istillvac,1);

popinhouse=ismember(1:length(Income(:,1)),con2lot(:,2))';
ioldpop=find(popinhouse==0 & Income(:,1)~=0);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%    Population    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

POP(1)=175;
NCON(1,1:TSTART)=length(Income(income1,1));
NCON(2,1:TSTART)=length(Income(income2,1));
NCON(3,1:TSTART)=length(Income(income3,1));

for tt=1:TSTART-2
    POP(tt+1)=round(POP(tt)*(1+POPGROW));
end
POP(TSTART)=sum(NCON(:,TSTART));
WCGROWTH=[1/3 1/3 1/3]';
FARMERPOS=AGLAYER;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%    Broker Info    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%@@@@@@@ Broker Projection Models @@@@@@@@@@@@@@@@@@

warning('off','all');
for n=1:Nbrokers
    str= sprintf('find(HBROKER == %d);',n);
    ibroker=eval(str);
    ibcellind=ismember(Lottype(:,2),ibroker);
    ibsample=Lottype(ibcellind,[1:2 5 7]);

    if isempty(ibsample) == 1
        continue
    else
        [iblots,ib,jb]=unique(ibsample(:,1));
        nbids=zeros([],1);
        for b=1:length(iblots)  
            bidover=(Phousebid(:,iblots(b)) > 0);
            nbids(b,1)=length(find(bidover==1));
        end
        
        % Calculate average utilities for rent projection of unknown
        % lottypes
        subrent=con2lot(iblots,1);
        subrent(con2lot(iblots,2)==0)=0;
        for sc=1:length(ibroker)
            isamecell=find(ibsample(:,2)==ibroker(sc));
            isnotvac=(ibsample(isamecell,4) ~= 0);
            if isempty(find(ibsample(isamecell(isnotvac),1),1)) == 1
                continue
            else
            avg_income(ibroker(sc))=median(Income(con2lot(ibsample(isamecell(isnotvac),1),2)));
            avg_alpha(ibroker(sc))=median(CONINFO(con2lot(ibsample(isamecell(isnotvac),1),2),1));
            avg_beta(ibroker(sc))=mean(CONINFO(con2lot(ibsample(isamecell(isnotvac),1),2),2));
            avg_gamma(ibroker(sc))=mean(CONINFO(con2lot(ibsample(isamecell(isnotvac),1),2),3));
            AVGUTIL(ibroker(sc))=((avg_income(ibroker(sc))-RENT(ibroker(sc))-...
                travelcost(ibroker(sc)))^avg_alpha(ibroker(sc)))*...
                (mean(z(ibsample(isamecell(isnotvac),3),2))^avg_beta(ibroker(sc)))*...
                (mean(z(ibsample(isamecell(isnotvac),3),1))^avg_gamma(ibroker(sc)));
            end
        end
        
        sampleinfo=zeros(length(iblots),5);
        sampleinfo(:,1)=subrent;
        sampleinfo(:,2)=lotchoice(iblots,3);
        sampleinfo(:,3)=lotchoice(iblots,4);
        sampleinfo(:,4)=nbids;
        sampleinfo(:,5)=con2lot(iblots,1)./(ccost(lotchoice(iblots,5))+...
            discount*PLAND(lotchoice(iblots,2)).*z(lotchoice(iblots,5),1));
        for lt=1:LTYPE*HTYPE
            ils=(ibsample(ib,3)==lt);                        
            houseinfo(lt,2,n,1)=z(lt,1);
            houseinfo(lt,3,n,1)=z(lt,2);
            if isempty(find(ils,1))==1
                houseinfo(lt,[1 4:6],n,1)=0;
            else
                houseinfo(lt,1,n,1)=mean(sampleinfo(ils,1));
                houseinfo(lt,4,n,1)=mean(sampleinfo(ils,4));
                houseinfo(lt,5,n,1)=min(sampleinfo(ils,5));
                houseinfo(lt,6,n,1)=length(find(ils==1));
            end
                isub=(ibsample(:,3) == lt);
                BIDLEVEL(ibsample(isub,2))=houseinfo(lt,5,n,1);
                EXPTHOUSE(ibsample(isub,2))=houseinfo(lt,1,n,1);
        end    
    end       
end

warning('on','all');
for lt=1:LTYPE*HTYPE
    numlt(lt,1)=length(find(LOTTYPE==lt))/z(lt,1);
    bidlevel(lt,TSTART)=mean(con2lot(lotchoice(:,5)==lt,1)./(ccost(lt)+...
        discount*PLAND(lotchoice(lotchoice(:,5)==lt,2)).*z(lt,1)));
end

for tt=2:TSTART+1
    houseinfo(:,:,:,tt)=houseinfo(:,:,:,1);
    numlt(:,tt)=numlt(:,1);
end

bcheck(:,1:Nbrokers)=houseinfo(:,1,1:Nbrokers,TSTART);
ibcheck=(bcheck' ~= 0);
htexist=ismember(1:LTYPE*HTYPE,LOTTYPE);
hset=htset(htexist);
for lt=1:LTYPE*HTYPE
    ihtexist=(ibcheck(:,lt)==1);
    if isempty(find(ihtexist,1))==1
        continue
    else
        avgbrokervar(lt,TSTART)=mean(var(brokerbestabsSAVE(ihtexist,lt,1:TSTART),0,3));
%         cvht(lt,TSTART)=std(mean(brokerbestabsSAVE(ihtexist,lt,1:TSTART),3))/...
%             mean(con2lot(lotchoice(:,5)==lt,1));
    end
    
end
ihtnexist=(htexist==0);
isimvar=hset(ismember(htset(htexist),min(simlotrange(htset(ihtnexist),1)):...
    max(simlotrange(htset(ihtnexist),2))));
avgbrokervar(ihtnexist,TSTART)=max(avgbrokervar(isimvar,TSTART));
% cvht(ihtnexist,TSTART)=max(cvht(isimvar,TSTART));
% avgbrokervar(:,TSTART)=mean(var(brokerbestdiffSAVE(:,:,1:TSTART),0,3),1);

house2cell(iurb)=1./z(LOTTYPE(iurb),1);
RENTGRAD(iurb)=RENT(iurb).*house2cell(iurb);

AGLAYER(iurb)=0;
iremain=(AGLAYER ~= 0);
iNfarmers=unique(AGLAYER(iremain));
landproj=mean(Plandproj(:,TSTART))*(1+min(max(randn(size(landproj)),-0.5),0.5));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%    RESULTS    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for lt=1:LTYPE*HTYPE
    irent=(houseinfo(lt,1,:,TSTART)~=0);
    avgrent(lt,TSTART)=mean(houseinfo(lt,1,irent,TSTART),3);
    
    ilt=find(lotchoice(:,5)==lt & lotchoice(:,7)==1 & BUILDTIME(lotchoice(:,2))==TSTART);
    budget_lt(lt,TSTART)=sum(con2lot(ilt,1)-PLAND(lotchoice(ilt,2)).*...
        z(lotchoice(ilt,5),1)*discount-lotchoice(ilt,6));
    vac_ccost(lt,TSTART)=sum(discount*(ccost(lt)+...
        PLAND(lotchoice(istillvac(lotchoice(istillvac,5)==lt),2))*z(lt,1)));
end

carrycost(TSTART)=sum(vac_ccost(:,TSTART));   
BUDGET(TSTART)=sum(budget_lt(:,TSTART));

INMAP=AGLAYER;
INMAP(iurb)=max(max(AGLAYER))+5;

ZONEMAP(iurb)=-5;

oldincome(TSTART)=mean(Income(ioldpop));
devcells(1,TSTART)=length(iurblist);
devcells(2,TSTART)=devcells(1,TSTART)/(NLENGTH*NWIDTH);
vacantlots(TSTART)=length(istillvac);
leftoverpop(TSTART)=length(ioldpop);

vacrate(TSTART)=vacantlots(TSTART)/Nlots(TSTART);
nohouserate(TSTART)=leftoverpop(TSTART)/POP(TSTART);

agrland(TSTART)=length(find(BASELAYER == 0));

consumerstats(1,TSTART)=Nconsumers;
consumerstats(4,TSTART)=mean(housemp);
consumerstats(2,TSTART)=mean(Income(con2lot(ifilled,2)));
consumerstats(3,TSTART)=mean(AVGUTIL(iurb));

BT(:,:,1)=BUILDTIME;
BL(:,:,1)=BIDLEVEL;
Rvacland(:,:,1)=VACLAND;
Rrent(:,:,1)=RENT;
Rlottype(:,:,1)=LOTTYPE;
Rbaselayer(:,:,1)=BASELAYER;
Rpland(:,:,1)=PLAND;
Rpop(1)=length(ifilled);
Rvacrate(1)=vacrate(TSTART);
Rvaclots(1)=vacantlots(TSTART);
Rnumlot(1)=numlt(TSTART);
Rleftoverpop(1)=leftoverpop(TSTART);
setupmap=AGLAYER;
Newlottype(:,:,TSTART)=LOTTYPE;
Ufinset=zeros(length(ifilled),1);

for ires=1:length(con2lot(ifilled,1))
    hopt=((Income(con2lot(ifilled(ires),2),1)-travelcost(lotchoice(ifilled(ires),2))-...
        avgrent(:,TSTART)).^CONINFO(con2lot(ifilled(ires),2),1)).*(z(:,2).^...
        CONINFO(con2lot(ifilled(ires),2),2)).*(z(:,1).^CONINFO(con2lot(ifilled(ires),2),3));
    [imaxu,jmaxu]=max(hopt,[],1);
    idealset(jmaxu,1)=idealset(jmaxu,1)+1;
end

for i=1:length(ifilled)
    conid=con2lot(ifilled(i),2);
    lotid=con2lot(ifilled(i),3);
    Ufinset(i)=(((Income(conid)-travelcost(lotchoice(ifilled(i),2))-...
        con2lot(ifilled(i),1)).^CONINFO(conid,1)).*...
        (lotchoice(ifilled(i),4).^CONINFO(conid,2)).*(lotchoice(ifilled(i),3).^...
        CONINFO(conid,3)))';
    
    profopt=(avgrent(:,TSTART)-ones(LTYPE*HTYPE,1)*PLAND(lotchoice(ifilled(i),2))-ccost)./z(:,1);
    [imaxp,jmaxp]=max(profopt,[],1);
    profset(jmaxp,1)=profset(jmaxp,1)+1;
end

Ufinset=sort(Ufinset,'descend');
utilgini(TSTART)=(length(Ufinset)+1)/(length(Ufinset)-1)-2/...
    (length(Ufinset)*(length(Ufinset)-1)*mean(Ufinset))*...
    sum((1:length(Ufinset))'.*Ufinset);

Incomeset=sort(Income(con2lot(ifilled,2)),'descend');
incgini(TSTART)=(length(Incomeset)+1)/(length(Incomeset)-1)-2/...
    (length(Incomeset)*(length(Incomeset)-1)*mean(Incomeset))*...
    sum((1:length(Incomeset))'.*Incomeset);

%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
%@@@@@@@@@@@@@@@@@@@@@@@@@    DYNAMICS    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

incon=find(Income(:,1)~=0);
iconleave=0;
Nconsumers=length(find(Income(:,1) ~= 0));

for t=TSTART+1:TMAX

    t
    ccost=ccost_base;
    lotchoice(:,6)=ccost(lotchoice(:,5));
    POP(t)=ceil(Nconsumers*(1+POPGROW));
    
    %Existing houses back on market <><><><><><><><><><><><><>
    ileave=find(con2lot(:,4)==t);
    lotchoice(ileave,7)=0;
    returncon=(con2lot(ileave,2)~=0);
    Income(con2lot(ileave(returncon),2),2)=t+...
        ceil(searchtimemin+(searchtimemax-searchtimemin)*rand(length(ileave(returncon)),1));
    for lt=1:LTYPE*HTYPE
        leavetype=(lotchoice(ileave,5)==lt);
        newopenlots(lt,t)=length(find(leavetype==1));
    end

    for ilv=1:length(ileave)
        iilots=find(Lottype(:,1)==ileave(ilv));
        lotchoice(ileave(ilv),7)=0;
        Lottype(iilots,7)=0;
    end
    iexisthouse=ileave;
    for lt=1:LTYPE*HTYPE
        numlt(lt,t)=length(find(LOTTYPE==lt))/z(lt,1);
    end

    for in=1:length(iNfarmers)
        ifarmland=(AGLAYER == iNfarmers(in));
        PLAND(ifarmland)=LOCWGHT*wtaland(iNfarmers(in),t-1)+REGWGHT*mean(mean(PLAND));
        Dynplandmap(:,:,t)=PLAND;
    end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%    Developer's Decisions    %%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    Ndevelopers=1;

    %Demand, by each lot

    reldemand=zeros(Nlots(t),1);
    ltype=zeros(Nlots(t),1);
    extrabid=zeros(Nlots(t),1);
    
    for lt=1:LTYPE*HTYPE
        iocc=(houseinfo(lt,1,:,t-1)~=0);
        if isempty(find(iocc,1))==1
            bidtot(lt,t)=0;
        else
            bidtot(lt,t)=mean(houseinfo(lt,4,iocc,t-1),3);
        end
    end
    for iii=1:Nlots(t)
        isamelot=find(Lottype(:,1) == lotchoice(iii,1));
        bidoverx=(Phousebid(:,iii) >= (Paskhouse(iii)));
        extrabid(iii,1)=length(find(bidoverx ==1));
        reldemand(iii,1)=extrabid(iii,1)-newopenlots(lotchoice(iii,5),t);
        XBIDS(Lottype(isamelot,2))=extrabid(iii,1);
    end
    % Rank housing types by their proportion of bids received last period
    trackbids=[extrabid reldemand lotchoice(:,[1:3 5])];
    demandrank=sortrows(trackbids,-1); %[#of_bids(sorted) relative_demand lotid ind lotsize lottype]
    
    bidrank=demandrank(:,[2 6]);
    
    for lt=1:LTYPE*HTYPE
        pctbuildold(lt,t)=sum(demandrank(demandrank(:,6)==lt,1))/...
            sum(demandrank(:,1));
        pctbuildnew(lt,t)=sum(demandrank(demandrank(:,6)==lt,1))/...
            sum(demandrank(:,1));
    end

    %%% Developer's Population Predictions %%%  
    for i = 1:POPNUMCLASS
        if i == 1
            % mirror models
            nproj(indclass1) = POP(t-1) - POP(t-2) + (1-dd(indclass1))*(0.5*POP(t-1) - (POP(t-1)-POP(t-2)));
        elseif i == 2
            % mean mode
            for j = 1:length(indclass2)
                nproj(indclass2(j)) = mean(POP((t-1):-1:(t-dd(indclass2(j)))));
            end
        elseif i == 3
            %cycle model
            nproj(indclass3) = POP(t-max(1,dd(indclass3)));
        elseif i == 4
            % projection model
            for j = 1:length(indclass4)
                yyy(j,1:dd(indclass4(j))) = POP((t-dd(indclass4(j))):(t-1));
            end
            sumy = sum(yyy,2);
            sumxy = sum(xxx.*yyy,2);
            slopes = (dd(indclass4)'.*sumxy - sumx.*sumy)./(dd(indclass4)'.*sumx2 - sumx.*sumx);
            intercepts = (sumy - slopes.*sumx)./dd(indclass4)';
            nproj(indclass4) = slopes + intercepts;
        elseif i == 5
            % rescale model
            nproj(indclass5) = dd(indclass5)*POP(t-1);
        end
    end
    
    errorsq = (1-DELTA)*errorsq + DELTA*(POP(t)-nproj).^2;
    [best(1:Ndevelopers) ibest(1:Ndevelopers)] = min(errorsq,[],2);
    bestPOPSAVE(1:Ndevelopers,t) = best;
    ibestPOPSAVE(1:Ndevelopers,t) = ibest;
    nprojSAVE(1:Ndevelopers,t) = nproj(ibest);
    
    numnewhouses(t)=round((nproj(ibest)-(length(ifilled)+length(ioldpop)-length(iconleave))));
    numoldhouses(t)=length(ioldpop)-length(istillvac);
    houseset=max(ceil(nproj(ibest)-sum(numlt(:,t))-length(istillvac)),0);
    newhouseset(:,t)=round(houseset.*(bidtot(:,t)./sum(bidtot(:,t))));
    
    %Spatial Rent discounting for all vacant cells
    nvac=length(iNfarmers);   %number of vacant plots the developer could buy
    iurb=(BASELAYER == 1);
    iurblist=find(iurb==1);
    ivac=(VACLAND ~= 0);
    ivaclist=find(ivac==1);

    for lt=1:LTYPE*HTYPE
        isimlots=(ismember(lotchoice(:,5),simlotrange(lt,1):...
            simlotrange(lt,2))==1 & lotchoice(:,7)~=0);
        isimcells=unique(Lottype(ismember(Lottype(:,1),lotchoice(isimlots,1)),2));
        
        %Regional Stats from similar housing types
        simlots_income(lt)=median(Income(con2lot(isimlots,2)));
        simlots_util(lt)=median(median(AVGUTIL(isimcells)));
        simlots_alpha(lt)=mean(mean(avg_alpha(isimcells)));
        simlots_beta(lt)=mean(mean(avg_beta(isimcells)));
        simlots_gamma(lt)=mean(mean(avg_gamma(isimcells))); 
        
        ireglot=(Lottype(:,5)==lt);
        if isempty(find(ireglot,1))==1
            continue
        else
            regionaldist(lt,t)=mean(DISTANCE(Lottype(ireglot,2)));
            regionalrent(lt,t)=mean(EXPTHOUSE(Lottype(ireglot,2)));
        end
    end

    reg_util=median(median(AVGUTIL(iurb)));
    reg_income=median(Income(con2lot(ifilled,2)));
    reg_alpha=mean(mean(avg_alpha(iurb)));
    reg_beta=mean(mean(avg_beta(iurb)));
    reg_gamma=mean(mean(avg_gamma(iurb)));
    
    B=regress(con2lot(ifilled,1),[ones(length(ifilled),1) ...
        log(Income(con2lot(ifilled,2))) log(lotchoice(ifilled,3:4)) ...
        travelcost(lotchoice(ifilled,2))]);
    
    ddist2hznnei=zeros(NLENGTH,NWIDTH);    %distance to horizontal neighbor from icenter
    ddist2vrtnei=zeros(NLENGTH,NWIDTH);
    potentialbuy=find(BASELAYER==0);
    for tl=1:length(potentialbuy)
        inddist2dev=10000*ones(NLENGTH,NWIDTH);
        [vacrow,vaccol]=ind2sub([NLENGTH NWIDTH],potentialbuy(tl));

        for col=1:NWIDTH
            ddist2hznnei(1:NLENGTH,col)=abs(col-vaccol).*...
                ones(NLENGTH,1);
            for row=1:NWIDTH
                ddist2vrtnei(row,1:NWIDTH)=abs(row-vacrow).*...
                    ones(1,NLENGTH);
                inddist2dev(row,col)=min(sqrt(ddist2hznnei(row,col)^2+...
                    ddist2vrtnei(row,col)^2),inddist2dev(row,col));
            end
        end
        subdist2dev=[inddist2dev(iurb) iurblist];
        sortdevdist=sortrows(subdist2dev,1);
        iclosedev=sortdevdist(:,2);
        
        for lt=1:LTYPE*HTYPE           
            zonecheck=zoning(ZONES(vacrow,vaccol),:);
            if z(lt,1) >= zonecheck(1) && z(lt,1) <= zonecheck(2)
                warning('off','all');
                likelotcount=round(numlt(lt,t));
                icountcells=iclosedev(1:round(length(iurblist)*PCTSEARCH));
                iutilcells=icountcells(AVGUTIL(icountcells)~=0 & ...
                    (ismember(LOTTYPE(icountcells),simlotrange(lt,1):...
                    simlotrange(lt,2))==1));
                distutils=inddist2dev(iutilcells);
                if isempty(distutils)==1
                    termrunflag=1;
                end
                avg_utils=median(AVGUTIL(iutilcells));
                avgalpha=sum(-distutils.*avg_alpha(iutilcells))/sum(-distutils);
                avgbeta=sum(-distutils.*avg_beta(iutilcells))/sum(-distutils);
                avggamma=sum(-distutils.*avg_gamma(iutilcells))/sum(-distutils);
                avgmoney=sum(-distutils.*avg_income(iutilcells))/sum(-distutils);
                warning('on','all');
                if likelotcount == 0        
                    subRENTPROJ(vacrow,vaccol,lt)=B(1)+...
                        B(2)*log(simlots_income(lt))+B(3)*log(z(lt,1))+...
                        B(4)*log(z(lt,2))+B(5)*travelcost(vacrow,vaccol);
                else
                    nclosecells=max(likelotcount*min(z(lt,1),1),round(length(iurblist)*PCTSEARCH));
                    isamecell=ismember(lotchoice(:,2),iclosedev(1:nclosecells));
                    iclosecells=find(isamecell==1);
                    icloselot=find(lotchoice(iclosecells,5) == lt,nclosecells,'first');
                    devrents=EXPTHOUSE(lotchoice(iclosecells(icloselot),2));
                    distrents=inddist2dev(lotchoice(iclosecells(icloselot),2));
                    [closecelldist,iclstcell]=min(distrents,[],1);
                    iclosestcell=lotchoice(iclosecells(icloselot(iclstcell)),2);
                    
                    if isempty(icloselot)==1
                        locrentproj=B(1)+...
                            B(2)*log(simlots_income(lt))+B(3)*log(z(lt,1))+...
                            B(4)*log(z(lt,2))+B(5)*travelcost(vacrow,vaccol);
                        regrentproj=regionalrent(lt,t)-margtc*...
                            (DISTANCE(vacrow,vaccol)-regionaldist(lt,t));
                        subRENTPROJ(vacrow,vaccol,lt)=LOCWGHT*locrentproj+...
                            REGWGHT*regrentproj;
%                         
                    else
                        locrentproj=(sum(-distrents.*devrents)/sum(-distrents))-...
                            margtc*distrents(iclstcell);
                        regrentproj=regionalrent(lt,t)-margtc*...
                            (DISTANCE(vacrow,vaccol)-regionaldist(lt,t));
                        subRENTPROJ(vacrow,vaccol,lt)=LOCWGHT*locrentproj+...
                            REGWGHT*regrentproj;
                    end
                end
                warning('on','all');

                RETURN(vacrow,vaccol,lt)=(1-discount)*(subRENTPROJ(vacrow,...
                    vaccol,lt)-ccost(lt))/z(lt,1)-carrycost(t-1)/...
                    ceil(sum(newhouseset(:,t).*z(:,1)));
            else
                RETURN(vacrow,vaccol,lt)=0;
            end
            subret=RETURN(:,:,lt);
            Exptret(lt,t)=mean(subret(potentialbuy));
        end
    end
    
    if isempty(find(newhouseset(:,t),1))==1
        LANDBUDGET(t)=0;
    else
        LANDBUDGET(t)=BUDGET(t-1)/round(sum(newhouseset(:,t).*z(:,1)));
    end
    indfarms=find(iagr==1);
    farmprojcells=zeros(length(iagr),3);     %[profitability ltype ind]
    [maxret,retind]=max(RETURN(:,:,1:LTYPE*HTYPE),[],3);
    
    for tl=1:length(potentialbuy)
        [vacrow,vaccol]=ind2sub([NLENGTH NWIDTH],potentialbuy(tl));
        iposret=find(RETURN(vacrow,vaccol,:) >= 0);
        posretset=reshape(RETURN(vacrow,vaccol,iposret),length(iposret),1);
        retbuildset=max(newhouseset(iposret,t),1);
        MAXRET(vacrow,vaccol,t)=sum(z(iposret,1).*retbuildset.*reshape(RETURN(vacrow,vaccol,...
            iposret),length(iposret),1))/sum(z(iposret,1).*retbuildset);
        WTPMAP(vacrow,vaccol,t)=MAXRET(vacrow,vaccol,t)/discount;
    end
       
    farmprojcells(1:length(indfarms),:)=[maxret(iagr) retind(iagr) indfarms];
    RETURNPROJ=maxret;

    Dynmaxretmap(:,:,t)=maxret;
    Dynretltmap(:,:,t)=retind;
    
    maxretcells=zeros([],3);
    iundev=(BASELAYER == 0);
    indundev=find(iundev==1);
    maxretcells(length(maxretcells(:,1))+1:length(maxretcells(:,1))+length(indundev),:)=...
        [RETURNPROJ(iundev) ones(length(indundev),1).*retind(iundev) ...
        indundev];
    rankmpcells=sortrows(maxretcells,-1);
    numnewacres(t)=ceil(sum(newhouseset(:,t).*z(:,1)));

    for ww=1:NWIDTH
        for ll=1:NLENGTH
            maxRENTPROJ(ll,ww)=subRENTPROJ(ll,ww,retind(ll,ww));
            CCOST(ll,ww)=ccost(retind(ll,ww));
            ZZ(ll,ww)=z(retind(ll,ww),1);
        end
    end
    
%<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
%<><><><><><><><><><> Go to Land Market <><><><><><><><><><><><><><><><><><>
%<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
    landdemand(1,t)=max(sum(numnewacres(t))-max(length(find(ivac==1)),...
        min(Farmstats(iNfarmers,2,t))),0);
    for rf=1:length(iNfarmers)       
        ifarmcalc=find(AGLAYER == iNfarmers(rf));
        subWTPMAP=WTPMAP(:,:,t);

        wtpland(iNfarmers(rf),t)=sum(subWTPMAP(ifarmcalc))/length(ifarmcalc);
    end
   
    LandMarket_6v0
    
    for ft=1:length(ifarmtrans)
        VACLAND(AGLAYER == ifarmtrans(ft))=1;
    end

%<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>

    ivac=(VACLAND ~= 0);
    indvac=find(ivac==1);
    PROFIT(:,:,t)=maxret-(PLAND.*discount);
    vcells=zeros([],3);
    for lt=1:LTYPE*HTYPE
        subprofit=(subRENTPROJ(:,:,lt)-((PLAND*z(lt,1).*discount)+ccost(lt)))/z(lt,1);
        subprofit(iurb)=-1;
        vcells(length(vcells(:,1))+1:length(vcells(:,1))+length(indvac),:)=...
            [subprofit(ivac) ones(length(indvac),1).*lt indvac]; 
        Exptprofit(lt,t)=mean(subprofit(ivac));
    end
    vcells=vcells(vcells(:,1) >= 0,:);
    rankvaccells=sortrows(vcells,-1);
  
    Dynmaxprofmap(:,:,t)=PROFIT(:,:,t);
    Dynprofltmap(:,:,t)=retind;
  
    %%%%%%%%%%%%%%% Profit-Driven Construction decisions %%%%%%%%%%%%%%%%%%
    newquota=sum(houseset);
    lotidmark=Nlots(t);
    newhousequota=newhouseset(:,t);
        
    while newquota > 0 || isempty(find(newhousequota,1))==0
        iadded=zeros([],1);        
        istartcell=find(rankvaccells(:,1),1);
        iadded(length(iadded)+1:length(iadded)+length(istartcell))=rankvaccells(istartcell,3);
        if isempty(istartcell)==1
            break
        end
        newlotsize=z(rankvaccells(istartcell,2),1);
        newlottype=rankvaccells(istartcell,2);
        
        newhousequota(newlottype)=newhousequota(newlottype)-max(1/newlotsize,1);
        
        isearchcells=istartcell;
        if newlotsize > 1
            newlottot=1;
            while newlottot < newlotsize
                % Look over 4 cardinal neighbors
                isnei=zeros(length(iadded),4);
                numnei=zeros(length(iadded),1);
                for sc=1:length(iadded)
                    [srows scols]=ind2sub([NLENGTH NWIDTH],iadded(sc));
                    srnei=(scols+1)*NLENGTH-(NWIDTH-srows);
                    slnei=(scols-1)*NLENGTH-(NWIDTH-srows);
                    supnei=scols*NLENGTH-(NWIDTH-(srows-1));
                    sdnnei=scols*NLENGTH-(NWIDTH-(srows+1));
                    isnei(sc,:)=[srnei slnei supnei sdnnei];
                    dblcount=(ismember(isnei(sc,:),iadded)==0);
                    novac=(ismember(isnei(sc,:),Lottype(:,2))==0);
                    owned=(ismember(isnei(sc,:),ivaclist)==1);
                    bound=(isnei(sc,:) > 0 & isnei(sc,:) <= (NLENGTH*NWIDTH));
                    dblcheck=dblcount.*novac.*bound.*owned;
                    isnei(sc,:)=isnei(sc,:).*dblcheck;
                    numnei(sc)=length(find(isnei(sc,:)~=0));
                end
                [maxnum,inei]=max(numnei,[],1);
                if isempty(find(numnei,1))==1
                    rankvaccells(istartcell,:)=0;
                    iadded=zeros([],1);
                    break
                end
                realsnei=zeros([],1);
                ikeep=(isnei ~= 0);
                ikeepstar=find(ikeep(inei,:)==1);
                
                for in=1:numnei(inei)                    
                    ivacnei=find(rankvaccells(:,3)==isnei(inei,ikeepstar(in)) ...
                        & rankvaccells(:,2)==newlottype);
                    if isempty(find(ivacnei,1))==1
                        realsnei(length(realsnei)+1)=isnei(inei,ikeepstar(in));
                        continue
                    end
                    realsnei(length(realsnei)+1)=rankvaccells(ivacnei,3);
                end
                % Randomize selection of new cells
                addopts=(1:length(realsnei));
                addopts=circshift(addopts,[0 round(length(addopts)*rand(1))]);
                numadd=min(length(realsnei)+newlottot,newlotsize);
                iadd=(1:numadd-newlottot);
                newbuildcells=realsnei(addopts(iadd));
                iadded(length(iadded)+1:length(iadded)+length(iadd),1)=...
                    realsnei(addopts(iadd));
               isearchcells=newbuildcells;

               doneswitch=newlottot+length(iadd);
                if doneswitch == newlotsize
                    totnewbuildcells=iadded;
                    BUILDTIME(totnewbuildcells)=t;
                    BASELAYER(totnewbuildcells)=1;
                    VACLAND(totnewbuildcells)=0;
                    Lottype(length(Lottype(:,1))+1:length(Lottype(:,1))+...
                        length(totnewbuildcells),:)=[ones(length(iadded),1).*(lotidmark+1) ...
                        totnewbuildcells ones(length(iadded),1)*[z(newlottype,1) ...
                        z(newlottype,2) newlottype ccost(newlottype)] zeros(length(iadded),1)];                     
                    newquota=newquota-1;
                    lotidmark=lotidmark+1;
                end
                newlottot=newlottot+length(iadd);
            end
        elseif newlotsize < 1
            totnewbuildcells=rankvaccells(istartcell,3);
            BUILDTIME(totnewbuildcells)=t;
            BASELAYER(totnewbuildcells)=1;
            VACLAND(totnewbuildcells)=0;
            namelength=1/newlotsize;
            Lottype(length(Lottype(:,1))+1:length(Lottype(:,1))+namelength,:)=...
                [(lotidmark+(1:namelength))' (([rankvaccells(istartcell,3) ...
                z(rankvaccells(istartcell,2),1) z(rankvaccells(istartcell,2),2) ...
                newlottype ccost(rankvaccells(istartcell,2)) 0])'*ones(1,namelength))'];
            newquota=newquota-namelength;
            lotidmark=lotidmark+namelength;
        else
            totnewbuildcells=rankvaccells(istartcell,3);
            BUILDTIME(totnewbuildcells)=t;
            BASELAYER(totnewbuildcells)=1;
            VACLAND(totnewbuildcells)=0;
            Lottype(length(Lottype(:,1))+1,:)=[lotidmark+1 rankvaccells(istartcell,3)...
                z(rankvaccells(istartcell,2),1) z(rankvaccells(istartcell,2),2)...
                newlottype ccost(rankvaccells(istartcell,2)) 0];
            newquota=newquota-1;
            lotidmark=lotidmark+1;
        end
        
        if newhousequota(newlottype)<=0
            rankvaccells(rankvaccells(:,2)==newlottype,:)=0;
        end

        for nls=1:length(iadded)
            isameind=find(rankvaccells(:,3)==iadded(nls));
            rankvaccells(isameind,:)=0;
        end
        
        iurb=(BASELAYER == 1);
        iagr=(BASELAYER == 0);
        iurblist=find(iurb==1);
        ivac=(VACLAND ~= 0);
        ivaclist=find(ivac==1);

        if isempty(find(ivac,1))
            break
        end
        if isempty(find(newhousequota,1))==1
            break
        end
    end
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    VACLAND(iurb)=0;
    ivac=(VACLAND ~= 0);
    ivaclist=find(ivac==1);

    lotchoice=zeros(Nlots(1),7);
    cellinfo=zeros(length(iurblist),7);
    [lotids,ilots,jnum]=unique(Lottype(:,1));
    lotchoice(lotids,:)=Lottype(ilots,:);
    Nlots(t)=length(lotchoice(:,1));

    [cellids,icells,jnumcell]=unique(Lottype(:,2));
    cellinfo(1:length(iurblist),:)=Lottype(icells,:);
    LOTTYPE(cellinfo(:,2))=cellinfo(:,5);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%    Farmer Price Prediction    %%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%% Spatially discounting observed land market prices to use in
    %%% prediction models
    % Calculate Distances to Transactions
    ntrans=length(ifarmtrans);   %numer of land market trans actions, farms sold.
    indtransdist=zeros(NLENGTH,NWIDTH,ntrans);
    transdist=zeros(NLENGTH,NWIDTH);
    Planddistproj=zeros(length(iNfarmers),ntrans);
    if ntrans > 0
        for nt=1:ntrans
            tdist2hznnei=10000*ones(NLENGTH,NWIDTH);    %distance to horizontal neighbor from icenter
            tdist2vrtnei=10000*ones(NLENGTH,NWIDTH);
            transland=find(AGLAYER==ifarmtrans(nt));
            for tl=1:length(transland)
                [itlrow,itlcol]=ind2sub([NLENGTH,NWIDTH],transland(tl));
                for col=1:NWIDTH
                    tdist2hznnei(1:NLENGTH,col)=min(abs(col-itlcol).*...
                        ones(NLENGTH,1),tdist2hznnei(1:NLENGTH,col));
                end
                for row=1:NWIDTH
                    tdist2vrtnei(row,1:NWIDTH)=min(abs(row-itlrow).*...
                        ones(1,NLENGTH),tdist2vrtnei(row,1:NWIDTH));
                end
                for col=1:NWIDTH
                    for row=1:NLENGTH
                        indtransdist(row,col,nt)=sqrt(tdist2hznnei(row,col)^2+tdist2vrtnei(row,col)^2);
                    end
                end
            end
            AGLAYER(transland)=0;
            iremain=(AGLAYER ~= 0);
            iNfarmers=unique(AGLAYER(iremain));
            %Calculate gradient coefficients using genetic algorithm
            subtransdist=indtransdist(:,:,nt);
            distcoeff(ifarmtrans,:)=0;
            for nf=1:length(iNfarmers)
                    rc=zeros([],1);
                    avgtransdist=mean(subtransdist(AGLAYER==iNfarmers(nf)));
                    coeffmark=(Paskland(iNfarmers(nf),t)-mean(PLAND(transland)))/...
                        avgtransdist;
                    fitness(iNfarmers(nf),:,t)=fitness(iNfarmers(nf),:,t-1)+...
                        abs(distcoeff(iNfarmers(nf),:)-coeffmark);
                    fitsort=sort(fitness(iNfarmers(nf),:,t),'ascend');
                    stratcount=1;
                    for x=1:nextgen
                        numstrat=find(fitness(iNfarmers(nf),:,t)==fitsort(x));
                        if length(numstrat) > 1
                            isurvive(x,1)=numstrat(stratcount);
                            stratcount=stratcount+1;
                        else
                            isurvive(x,1)=numstrat(stratcount);
                        end
                        if stratcount > length(numstrat)
                            stratcount=1;
                        end
                    end
                    distcoeff(iNfarmers(nf),1:nextgen)=distcoeff(iNfarmers(nf),isurvive);
                    for xx=1:nextgen
                        irc=xx*recombo/nextgen;
                        rc(length(rc)+1:irc,1)=distcoeff(iNfarmers(nf),xx)+rand(1,4);
                    end
                    distcoeff(iNfarmers(nf),nextgen+1:nextgen+recombo)=rc';
                    distcoeff(iNfarmers(nf),nextgen+recombo+1:NUMMODELDIST)=...
                        mincoeff+(maxcoeff-mincoeff)*rand(1,NUMMODELDIST-...
                        (nextgen+recombo));
            end
            Planddistproj(iNfarmers,nt)=distcoeff(iNfarmers,1).*avgtransdist+...
                mean(PLAND(transland));
        end
        for nnw=1:NWIDTH
            for nnl=1:NLENGTH
                transdist(nnl,nnw)=min(indtransdist(nnl,nnw,1:ntrans));
            end
        end
        Plandproj(iNfarmers,t)=mean(Planddistproj(iNfarmers,:),2);
    else
        Plandproj(iNfarmers,t)=(1-DELTA)*Plandproj(iNfarmers,t-1)+DELTA*...
            mean([wtaland(iNfarmers,t) zeta*wtpland(iNfarmers,t)],2);
    end
    %%% Farmers' Prediction Models %%%
    for nf=1:length(iNfarmers)
        ilandclass1=find(landmodel(iNfarmers(nf),:)==1);
        ilandclass2=find(landmodel(iNfarmers(nf),:)==2);
        ilandclass3=find(landmodel(iNfarmers(nf),:)==3);
        ilandclass4=find(landmodel(iNfarmers(nf),:)==4);
        ilandclass5=find(landmodel(iNfarmers(nf),:)==5);
        ilandclass6=find(landmodel(iNfarmers(nf),:)==6);
        
        landerror(iNfarmers(nf),:) = (1-DELTA)*landerror(iNfarmers(nf),:)+...
            DELTA*abs(Plandproj(iNfarmers(nf),t)-landproj(iNfarmers(nf),:));
        [landbest ilandbest] = min(landerror(iNfarmers(nf),:),[],2);
        landbestSAVE(iNfarmers(nf),t) = landbest;
        ilandbestSAVE(iNfarmers(nf),t) = ilandbest;
        landprojSAVE(iNfarmers(nf),t) = landproj(iNfarmers(nf),ilandbest);
        landmodelSAVE(iNfarmers(nf),t) = landmodel(iNfarmers(nf),ilandbest);
        
        for i = 1:FARMNUMCLASS
            if i == 1
                % mirror models
                landproj(iNfarmers(nf),ilandclass1) = Plandproj(iNfarmers(nf),t)+(1-aa...
                    (iNfarmers(nf),ilandclass1)).*(0.5*Plandproj(iNfarmers(nf),t)-...
                    (Plandproj(iNfarmers(nf),t)-Plandproj(iNfarmers(nf),t-1)));
            elseif i == 2
                % mean model
                for jl = 1:length(ilandclass2)
                    landproj(iNfarmers(nf),ilandclass2(jl)) = mean(Plandproj(iNfarmers(nf),...
                        t:-1:(t-aa(iNfarmers(nf),ilandclass2(jl)))));
                end
            elseif i == 3
                %cycle model
                landproj(iNfarmers(nf),ilandclass3) = Plandproj(iNfarmers(nf),...
                    t-round(max(1,aa(iNfarmers(nf),ilandclass3))));
            elseif i == 4
                % projection model
                for jl = 1:length(ilandclass4)
                    %Nonlinear Forecast
                    indata=Plandproj(iNfarmers(nf),t-(1+aa(iNfarmers(nf),ilandclass4(jl))):t);
                    pcoef=polyfit(1:length(indata),indata,1);
                    pline=pcoef(1).*(1:length(indata)+1)+pcoef(2);
                    landproj(iNfarmers(nf),ilandclass4(jl))=pline(length(pline));
                end
            elseif i == 5
                % rescale model
                landproj(iNfarmers(nf),ilandclass5) = aa(iNfarmers(nf),...
                    ilandclass5)*Plandproj(iNfarmers(nf),t);
            elseif i == 6
                % local(0) or regional(1) trends
                ilandlocal=(aa(iNfarmers(nf),ilandclass6)==0);
                ilandreg=(aa(iNfarmers(nf),ilandclass6)==1);
                if isempty(iNfarmers)==1
                    break
                end
                landproj(iNfarmers(nf),ilandclass6(ilandlocal)) = Plandproj...
                    (iNfarmers(nf),t).*(1+1/length(iNfarmers));
            end
        end
        wtaland(iNfarmers(nf),t+1)=max(landproj(iNfarmers(nf),ilandbest),...
            Farmstats(iNfarmers(nf),5,1));
    end




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%    Consumers' Choices    %%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%% Add new consumers %%%%%%%%%%
    newpop=ceil(Nconsumers*POPGROW);
    inewpop=(length(Income)+1:length(Income)+newpop);
    Income(inewpop,1)=min(max(normrnd(avgincome,stdincome,newpop,1),minwage),maxwage);
    Income(inewpop,2)=t+ceil(searchtimemin+(searchtimemax-searchtimemin)*rand(length(inewpop),1));
    
    incon=find(Income(:,1)~=0);
    
    newincome3=(Income(inewpop,1) >= lowminwage & Income(inewpop,1) <= lowmaxwage);     %income 1 2 3 = hi mid low wages
    newincome2=(Income(inewpop,1) >= midminwage & Income(inewpop,1) <= midmaxwage);
    newincome1=(Income(inewpop,1) >= himinwage & Income(inewpop,1) <= himaxwage);
    housepref(inewpop,1)=0;
    housepref(inewpop(newincome1),1)=0.20+(0.24-0.20)*rand(length(find(newincome1==1)),1);
    housepref(inewpop(newincome2),1)=0.25+(0.29-0.25)*rand(length(find(newincome2==1)),1);
    housepref(inewpop(newincome3),1)=0.30+(0.50-0.30)*rand(length(find(newincome3==1)),1);
    
    Hbeta=housepref(inewpop);
    beta=(0.1+(0.9-0.1)*rand(length(Hbeta),1)).*Hbeta;     %cite Carliner
    gamma=Hbeta-beta;   %cite Carliner
    alpha=(1-Hbeta);                                 %" " " " " consumer goods
    CONINFO(inewpop,:)=0;
    CONINFO(inewpop,1)=alpha;
    CONINFO(inewpop,2)=beta;
    CONINFO(inewpop,3)=gamma;

    income3=(Income(:,1) >= lowminwage & Income(:,1) <= lowmaxwage);     %income 1 2 3 = hi mid low wages
    income2=(Income(:,1) >= midminwage & Income(:,1) <= midmaxwage);
    income1=(Income(:,1) >= himinwage & Income(:,1) <= himaxwage);

%<><><><><><><><>  Matching consumers with houses  <><><><><><><><><><><><>
    minprof=zeros(Nlots(t),1);
    inewlots=find(lotchoice(:,7)==0);
    newcons=find(con2lot(:,2)~=0 & con2lot(:,4)==t);
    oldreturn=(Income(ioldpop,1)~=0);
    inewcon=sort([con2lot(newcons,2)' ioldpop(oldreturn)' inewpop]','ascend');

    for nl=1:length(inewlots)
        isamelot=find(Lottype(:,1)==lotchoice(inewlots(nl),1));
        RENTPROJ=subRENTPROJ(:,:,lotchoice(inewlots(nl),5));
        if BUILDTIME(lotchoice(inewlots(nl),2)) < t
            Paskhouse(inewlots(nl))=con2lot(inewlots(nl),1);
        else
            Paskhouse(inewlots(nl))=max(mean(RENT(Lottype(isamelot,2))),...
                mean(RENTPROJ(Lottype(isamelot,2))));
        end
    end

    con2lot(ileave,2)=0;
    con2lot(Nlots(t-1)+1:Nlots(t),:)=0;     %[WinBid conid lotid restime]
    con2lot(Nlots(t-1)+1:Nlots(t),3)=Nlots(t-1)+1:Nlots(t);
    
    %<><><><><><><><><><> Go to housing market <><><><><><><><><><><><><><><><>
    
    HouseMarketDynamic

    house2cell(iurb)=1./z(LOTTYPE(iurb),1);
    RENTGRAD(iurb)=RENT(iurb).*house2cell(iurb);
%<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
    popinhouse=ismember(1:length(Income),con2lot(:,2))';
    ioldpop=find(popinhouse==0 & Income(:,1)~=0);
    oldincome(t)=mean(Income(ioldpop));
    RENTPROJ(iurb)=0;
    Nlots(t+1)=Nlots(t);
    for lt=1:LTYPE*HTYPE
        isamelot=(lotchoice(istillvac,5)==lt);
        vacstats(lt,t)=length(find(isamelot==1));
    end
    devcells(1,t)=length(iurblist);
    devcells(2,t)=devcells(1,t)/(NLENGTH*NWIDTH);
    
    vacantlots(t)=length(istillvac);
    leftoverpop(t)=length(ioldpop);
    
    vacrate(t)=vacantlots(t)/Nlots(t);
    nohouserate(t)=leftoverpop(t)/POP(t);
    
    %Consumers leave area
    iconleave=find(Income(:,2) == t);
    OutIncome(length(OutIncome)+1:length(OutIncome)+length(iconleave),1:2)=...
        Income(iconleave,:);
    Income(iconleave,:)=0;
    Nconsumers=length(find(Income(:,1)~=0));
    
    subrealret=zeros(NLENGTH,NWIDTH);
    subexptrent=zeros(NLENGTH,NWIDTH);
    subnewlt=zeros(NLENGTH,NWIDTH);
    subnewbid=zeros(NLENGTH,NWIDTH);
    subrealexptret=zeros(NLENGTH,NWIDTH);

    for nl=1:length(inewlots)
        isamelot=find(Lottype(:,1)==lotchoice(inewlots(nl),1));
        isamecell=find(Lottype(:,2)==Lottype(isamelot(1),2));
        if length(isamecell) > 1
            subexptrent(Lottype(isamelot,2))=mean(con2lot(Lottype(isamecell,1),1)-...
                Paskhouse(Lottype(isamecell,1)));
            subrealret(Lottype(isamelot,2))=mean((con2lot(Lottype(isamecell,1),1)...
                -((PLAND(Lottype(isamecell,2)).*z(Lottype(isamecell,5),1)*discount)+...
                ccost(lotchoice(inewlots(nl),5)))));
            subrealexptret(Lottype(isamelot,2))=mean((Paskhouse(Lottype(isamecell,1))...
                -((PLAND(Lottype(isamecell,2)).*z(Lottype(isamecell,5),1)*discount)+...
                ccost(lotchoice(inewlots(nl),5)))));
            subnewbid(Lottype(isamelot,2))=mean(con2lot(Lottype(isamecell,1),1)./...
                Paskhouse(Lottype(isamecell,1)));
        else
        subexptrent(Lottype(isamelot,2))=con2lot(inewlots(nl),1)-Paskhouse(inewlots(nl));
        subrealret(Lottype(isamelot,2))=(con2lot(inewlots(nl),1)-...
            ((PLAND(lotchoice(inewlots(nl),2)).*z(lotchoice(inewlots(nl),5),1)*discount)+...
            ccost(lotchoice(inewlots(nl),5))));   
        subrealexptret(Lottype(isamelot,2))=(Paskhouse(inewlots(nl))-...
            ((PLAND(lotchoice(inewlots(nl),2)).*z(lotchoice(inewlots(nl),5),1)*discount)+...
            ccost(lotchoice(inewlots(nl),5))));
        subnewlt(Lottype(isamelot,2))=lotchoice(inewlots(nl),5);
        subnewbid(Lottype(isamelot,2))=con2lot(inewlots(nl),1)/Paskhouse(inewlots(nl));
        end
    end
    Exptrentdiff(:,:,t)=subexptrent;
    Realreturn(:,:,t)=subrealret;
    Realexptret(:,:,t)=subrealexptret;
    vac_land(t)=sum(PLAND(ivac)*discount);
    for lt=1:LTYPE*HTYPE
        avgrent(lt,t)=mean(RENT(LOTTYPE==lt));
        ifindlt=(lotchoice(inewlots,5)==lt);
        Avgexptdiff(lt,t)=mean(subexptrent(lotchoice(inewlots(ifindlt),2)));
        Realavgret(lt,t)=mean(subrealret(lotchoice(inewlots(ifindlt),2)));
        Realavgexptret(lt,t)=mean(subrealexptret(lotchoice(inewlots(ifindlt),2)));
        Avgnewbid(lt,t)=mean(subnewbid(lotchoice(inewlots(ifindlt),2)));

        ilt=find(lotchoice(istillvac,5)==lt);
        vac_ccost(lt,t)=sum(discount*(lotchoice(istillvac(ilt),6)+...
            PLAND(lotchoice(istillvac(ilt),2)).*z(lotchoice(istillvac(ilt),5),1)));
        vac_rent(lt,t)=sum(Paskhouse(istillvac(ilt)));
        
        ilt_t=find(lotchoice(:,5) == lt & BUILDTIME(lotchoice(:,2)) == t);
        profits(lt,t)=sum(con2lot(ilt_t,1)-(PLAND(lotchoice(ilt_t,2)).*...
            z(lotchoice(ilt_t,5),1)*discount+lotchoice(ilt_t,6)));
        budget_lt(lt,t)=profits(lt,t)-vac_ccost(lt,t);
    end
    Newlottype(:,:,t)=subnewlt;
    Newbidlevel(:,:,t)=subnewbid;
    carrycost(t)=sum(vac_ccost(:,t))+vac_land(t);
    
    BUDGET(t)=BUDGET(t-1)+sum(budget_lt(:,t))-vac_land(t);
           

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%    Brokers' Price Projections    %%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    warning('off','all');
    for nb=1:Nbrokers
        str= sprintf('find(HBROKER == %d);',nb);
        ibroker=eval(str);
        ibcellind=ismember(Lottype(:,2),ibroker);
        ibsample=Lottype(ibcellind,[1:2 5 7]);
        
        if isempty(ibsample) == 1
            continue
        else
            [iblots,ib,jb]=unique(ibsample(:,1));
            nbids=zeros([],1);
            inewbids=find(ismember(inewlots,iblots)==1);
            for b=1:length(iblots)
                bidover=(Phousebid(:,iblots(b)) > 0);
                nbids(b,1)=length(find(bidover==1));
            end

            for sc=1:length(ibroker)
                isamecell=find(ibsample(:,2)==ibroker(sc));
                isnotvac=(ibsample(isamecell,4) ~= 0);
                if isempty(find(ibsample(isamecell(isnotvac),1),1)) == 1
                    continue
                else
                    avg_income(ibroker(sc))=median(Income(con2lot(ibsample(isamecell(isnotvac),1),2)));
                    avg_alpha(ibroker(sc))=median(CONINFO(con2lot(ibsample(isamecell(isnotvac),1),2),1));                    
                    avg_beta(ibroker(sc))=mean(CONINFO(con2lot(ibsample(isamecell(isnotvac),1),2),2));
                    avg_gamma(ibroker(sc))=mean(CONINFO(con2lot(ibsample(isamecell(isnotvac),1),2),3));
                    AVGUTIL(ibroker(sc))=((avg_income(ibroker(sc))-RENT(ibroker(sc))-...
                        travelcost(ibroker(sc)))^avg_alpha(ibroker(sc)))*...
                        (mean(z(ibsample(isamecell(isnotvac),3),2))^avg_beta(ibroker(sc)))*...
                        (mean(z(ibsample(isamecell(isnotvac),3),1))^avg_gamma(ibroker(sc)));
                end
            end
            
            subrent=con2lot(iblots,1);
            subrent(con2lot(iblots,2)==0)=0;
            sampleinfo=zeros(length(iblots),5);
            sampleinfo(:,1)=subrent;
            sampleinfo(:,2)=lotchoice(iblots,3);
            sampleinfo(:,3)=lotchoice(iblots,4);
            sampleinfo(:,4)=nbids;
            sampleinfo(:,5)=con2lot(iblots,1)./(ccost(lotchoice(iblots,5))+...
                discount*Farmstats(FARMERPOS(lotchoice(iblots,2)),5,1).*...
                z(lotchoice(iblots,5),1));
            for lt=1:LTYPE*HTYPE
                ils=(ibsample(ib,3)==lt);
                
                houseinfo(lt,2,nb,t)=z(lt,1);
                houseinfo(lt,3,nb,t)=z(lt,2);
                if isempty(find(ils,1))==1
                    houseinfo(lt,[1 4:6],nb,t)=0;
                else
                    houseinfo(lt,1,nb,t)=mean(sampleinfo(ils,1));
                    houseinfo(lt,4,nb,t)=mean(sampleinfo(ils,4));
                    houseinfo(lt,5,nb,t)=mean(sampleinfo(ils,5));
                    houseinfo(lt,6,nb,t)=length(find(ils==1));
                end
                if isempty(find(houseinfo(lt,5,nb,t),1))==0
                    BIDLEVEL(ibsample(ibsample(:,3)==lt,2))=houseinfo(lt,5,nb,t);
                end
                bidlevel(lt,t)=mean(con2lot(lotchoice(:,5)==lt,1)./(ccost(lt)+...
                    discount*Farmstats(FARMERPOS(lotchoice(lotchoice(:,5)==lt,2)),5,1).*z(lt,1)));
            end
        end
        warning('on','all');

        

        bb=bbfull(:,:,nb);
        for lt=1:LTYPE*HTYPE
            brokererror(lt,:,nb,t) = (1-DELTA)*brokererror(lt,:,nb,t-1)+...
                DELTA*abs(houseinfo(lt,1,nb,t)-brokerproj(lt,:,nb));
            brokerabserror(lt,:,nb,t)=houseinfo(lt,1,nb,t)-brokerproj(lt,:,nb);
            [brokerbest ibrokerbest] = min(brokererror(lt,:,nb,t),[],2);
            diffbrokererror(lt,:,nb,t)=brokererror(lt,:,nb,t)-brokererror(lt,:,nb,t-1);
            brokerbestabsSAVE(nb,lt,t)=brokerabserror(lt,ibrokerbest,nb,t);
            brokerbestdiffSAVE(nb,lt,t)=diffbrokererror(lt,ibrokerbest,nb,t);
            brokerbestSAVE(nb,lt,t) = brokerbest';
            ibrokerbestSAVE(nb,lt,t) = ibrokerbest';
            brokerprojSAVE(nb,lt,t) = brokerproj(lt,ibrokerbest,nb);
            brokermodelSAVE(nb,lt,t) = brokermodel(lt,ibrokerbest,nb);
            for i = 1:BROKERNUMCLASS
                strb = sprintf('brokerclass%d = find(brokermodel(lt,:,nb) == %d);',i,i);
                eval(strb);
            end
            if houseinfo(lt,1,nb,t) == 0
                bproj(lt,:)=0;
            else
                for i = 1:BROKERNUMCLASS
                    if i == 1
                        % mirror models
                       bproj(lt,brokerclass1) = houseinfo(lt,1,nb,t)+(1-bb...
                            (lt,brokerclass1)).*(0.5*houseinfo(lt,1,nb,t)-...
                            (houseinfo(lt,1,nb,t)-houseinfo(lt,1,nb,t-1)));
                    elseif i == 2
                        % mean model
                        for jl = 1:length(brokerclass2)
                            bproj(lt,brokerclass2(jl)) = mean(houseinfo(lt,1,nb,...
                                t:-1:(t-bb(lt,brokerclass2(jl)))));
                        end
                    elseif i == 3
                        %cycle model
                        bproj(lt,brokerclass3) = houseinfo(lt,1,nb,t-...
                            round(max(1,bb(lt,brokerclass3))));
                    elseif i == 4
                        % projection model
                        for jl = 1:length(brokerclass4)
                            %Nonlinear Forecast
                            indata=houseinfo(lt,1,nb,t-(1+bb(lt,brokerclass4(jl))):t);
                            subindata=reshape(indata,1,length(indata));
                            pcoef=polyfit(1:length(indata),subindata,1);
                            pline=pcoef(1).*(1:length(indata)+1)+pcoef(2);
                            bproj(lt,brokerclass4(jl))=pline(length(pline));
                        end
                    elseif i == 5
                        % rescale model
                        bproj(lt,brokerclass5) = bb(lt,brokerclass5)*houseinfo(lt,1,nb,t);
                    elseif i == 6
                        [brows bcols]=ind2sub([nbrokerlong nbrokerwide],nb);
                        brnei=(bcols+1)*nbrokerlong-(nbrokerwide-brows);
                        blnei=(bcols-1)*nbrokerlong-(nbrokerwide-brows);
                        bupnei=bcols*nbrokerlong-(nbrokerwide-(brows-1));
                        bdnnei=bcols*nbrokerlong-(nbrokerwide-(brows+1));
                        ibnei=[brnei blnei bupnei bdnnei];
                        realbnei=find(minibmap==brnei | minibmap==blnei | ...
                            minibmap==bupnei | minibmap==bdnnei);
                        bproj(lt,brokerclass6) = bb(lt,brokerclass6)*mean(houseinfo(lt,1,realbnei,t));
                    end
                end
            end
            
            isub=(ibsample(:,3) == lt);
            EXPTHOUSE(ibsample(isub,2))=bproj(lt,ibrokerbest);

            numlt(lt,t)=length(find(LOTTYPE==lt))/z(lt,1);   
        end
        brokerproj(:,:,nb)=bproj;
    end
    bcheck(:,1:Nbrokers)=houseinfo(:,1,1:Nbrokers,t);
    ibcheck=(bcheck' ~= 0);
    htexist=ismember(1:LTYPE*HTYPE,LOTTYPE);
    hset=htset(htexist);
    for lt=1:LTYPE*HTYPE
        ihtexist=(ibcheck(:,lt)==1);
        if numlt(lt,t) >= 2 && length(find(lotchoice(lotchoice(:,5)==lt,7)==1)) >= 2
            avgbrokervar(lt,t)=0.5*avgbrokervar(lt,t-1)+...
                0.5*mean(var(brokerbestabsSAVE(ihtexist,lt,t)));
        else
            isimvar=hset(ismember(htset(numlt(:,t)>=2),min(simlotrange(htset(lt),1)):...
                max(simlotrange(htset(lt),2))));
            avgbrokervar(lt,t)=max(avgbrokervar(isimvar,t));
        end 
        
    end
    
    numtotbids(:,t)=sum(houseinfo(:,4,:,t),3);
    for lt=1:LTYPE*HTYPE
        iocc=(con2lot(:,2)~=0 & lotchoice(:,5)==lt);
        htincome(lt,t)=mean(Income(con2lot(iocc,2)));
    end
    
    consumerstats(1,t)=Nconsumers;
    consumerstats(4,t)=mean(housemp);
    consumerstats(2,t)=mean(Income(con2lot(ifilled,2)));
    consumerstats(3,t)=mean(AVGUTIL(iurb));
    consumerstats(5,t)=mean(OutIncome(:,1));
    Farmstats(iNfarmers,:,t+1)=Farmstats(iNfarmers,:,t);
    agrland(t)=length(find(BASELAYER==0));
    
    if isempty(find(t == testtime,1))==0
        tmark=find(t == testtime);
        BT(:,:,tmark)=BUILDTIME;
        BL(:,:,tmark)=BIDLEVEL;
        Rvacland(:,:,tmark)=VACLAND;
        Rrent(:,:,tmark)=RENT;
        Rlottype(:,:,tmark)=LOTTYPE;  
        Rbaselayer(:,:,tmark)=BASELAYER;
        
        for ires=1:length(con2lot(ifilled,1))
            hopt=((Income(con2lot(ifilled(ires),2),1)-travelcost(lotchoice(ifilled(ires),2))-...
                avgrent(:,t)).^CONINFO(con2lot(ifilled(ires),2),1)).*(z(:,2).^...
                CONINFO(con2lot(ifilled(ires),2),2)).*(z(:,1).^CONINFO(con2lot(ifilled(ires),2),3));
            [imaxu,jmaxu]=max(hopt,[],1);
            idealset(jmaxu,tmark)=idealset(jmaxu,tmark)+1;
        end
        
        for i=1:length(ifilled)
            profopt=(avgrent(:,t)-ones(LTYPE*HTYPE,1)*PLAND(lotchoice(ifilled(i),2)).*...
                z(:,1).*discount-ccost)./z(:,1);
            [imaxp,jmaxp]=max(profopt,[],1);
            profset(jmaxp,tmark)=profset(jmaxp,tmark)+1;
        end
        
        for lt=1:LTYPE*HTYPE
            iret=find(LOTTYPE==lt);
            if isempty(iret)==1
                continue
            end
            subRreturn(iret)=(RENT(iret)-((PLAND(iret).*z(lt,1).*...
                discount)+ccost(lt)))./z(lt,1);
        end
        Rreturn(:,:,tmark)=subRreturn;   

        for ii=1:length(con2lot(:,3))
            isamelot=find(Lottype(:,1)==lotchoice(ii,1));
            isamecell=find(lotchoice(:,2)==lotchoice(ii,2));
            if length(isamelot)==1
                if length(isamecell) == 1 && con2lot(isamecell,2)~= 0
                    AVGINCOME(lotchoice(isamecell,2))=Income(con2lot(ii,2));
                elseif length(isamecell) > 1 && isempty(find(con2lot(isamecell,2)~=0,1))==0
                    AVGINCOME(lotchoice(isamecell,2))=mean(Income(con2lot...
                        (isamecell(con2lot(isamecell,2)~=0),2)));
                elseif isempty(find(con2lot(isamecell,2)~=0,1)) == 1
                    AVGINCOME(lotchoice(isamecell,2))=0;
                end
            elseif length(isamelot) > 1
                if con2lot(isamecell,2) ~= 0
                    AVGINCOME(Lottype(isamelot,2))=Income(con2lot(isamecell,2));
                elseif con2lot(isamecell,2) == 0
                    AVGINCOME(lotchoice(isamecell,2))=0;
                end                
            end           
        end
        Rincome(:,:,tmark)=AVGINCOME;
        Rpland(:,:,tmark)=PLAND;
        Rpop(tmark)=length(ifilled);
        Rvacrate(tmark)=vacrate(t);
        Rvaclots(tmark)=vacantlots(t);
        Rnumlot(tmark)=numlt(t);
        Rleftoverpop(tmark)=leftoverpop(t);
    end
    
    ibuildtime=find(BUILDTIME==t);
    iltype=ismember(Lottype(:,2),ibuildtime);
    subdynlt(Lottype(iltype,2))=Lottype(iltype,5);
    subdynrent(Lottype(iltype,2))=con2lot(Lottype(iltype,1),1);
    dynbaselayer=(subdynlt~=0);
    Dynltmap(:,:,t)=subdynlt;
    Dynrentmap(:,:,t)=subdynrent;
    
    for lt=1:LTYPE*HTYPE
        htperyear(lt,t)=length(find(Newlottype(:,:,t)==lt))/z(lt,1);
    end
    alldevdist=10000*ones(NLENGTH,NWIDTH);
    transland=find(Dynltmap(:,:,t)~=0);
    for tl=1:length(transland)
        tdist2hznnei=10000*ones(NLENGTH,NWIDTH);    %distance to horizontal neighbor from icenter
        tdist2vrtnei=10000*ones(NLENGTH,NWIDTH);
        [itlrow,itlcol]=ind2sub([NLENGTH,NWIDTH],transland(tl));
        for col=1:NWIDTH
              tdist2hznnei(1:NLENGTH,col)=abs(col-itlcol).*...
                ones(NLENGTH,1);
        end
        for row=1:NWIDTH
              tdist2vrtnei(row,1:NWIDTH)=abs(row-itlrow).*...
                ones(1,NLENGTH);
        end
        for col=1:NWIDTH
            for row=1:NLENGTH
                alldevdist(row,col)=min(sqrt(tdist2hznnei(row,col)^2+...
                    tdist2vrtnei(row,col)^2),alldevdist(row,col));
            end
        end
    end
    for nf=1:Nfarmers
        Farmdist2dev(nf,t)=mean(alldevdist(FARMERPOS==nf));
    end
    subbmodel=zeros(NLENGTH,NWIDTH);
    subbproj=zeros(NLENGTH,NWIDTH);
    for nb=1:Nbrokers
        for lt=1:LTYPE*HTYPE
            totbrokerrecord(:,lt,t,nb)=[houseinfo(lt,1,nb,t); brokerprojSAVE(nb,lt,t); ...
                brokermodelSAVE(nb,lt,t)];
            ibarea=find(HBROKER==nb);
            idynlt=find(subdynlt==lt);
            itarget=ismember(idynlt,ibarea);
            subbmodel(idynlt(itarget))=brokermodelSAVE(nb,lt,t);
            subbproj(idynlt(itarget))=brokerprojSAVE(nb,lt,t);
            
        end
    end
    Bmodelmap(:,:,t)=subbmodel;
    Bprojmap(:,:,t)=subbproj;
end
